#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>

void yes_clicked(GtkWidget * widget, GtkWidget * mywin)
{
  gtk_main_quit();
  exit(0);
}

void no_clicked(GtkWidget * widget, GtkWidget * mywin)
{
  gtk_main_quit();
  exit(1);
}

int main(int argc, char ** argv){
  GtkWidget *mywin, *vbox, *hbox, *label, *spacer, *yes, *no, *big_hbox, *ospacer;
  if(argc != 2) {
    printf("Usage: %s \"message\"\n", argv[0]);
    exit(1);
  }
  gtk_init(&argc, &argv);
  // TODO: use the theme dir variable
  gtk_rc_add_default_file("/usr/share/ldm/themes/ltsp/greeter-gtkrc");
  mywin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_position(GTK_WINDOW(mywin), GTK_WIN_POS_CENTER_ALWAYS);
  vbox = gtk_vbox_new(FALSE, 0);
  hbox = gtk_hbox_new(FALSE, 3);
  spacer = gtk_label_new("");
  ospacer = gtk_label_new("");
  gtk_widget_set_size_request(ospacer, 0, 8);
  gtk_box_pack_start(GTK_BOX(hbox), spacer, TRUE, FALSE, 0);
  yes = gtk_button_new_with_label("Yes");
  no = gtk_button_new_with_label("No");
  gtk_button_set_image(GTK_BUTTON(yes), gtk_button_get_image(GTK_BUTTON(gtk_button_new_from_stock("gtk-ok"))));
  gtk_button_set_image(GTK_BUTTON(no), gtk_button_get_image(GTK_BUTTON(gtk_button_new_from_stock("gtk-cancel"))));
  gtk_widget_set_size_request(yes, 80, 30);
  gtk_widget_set_size_request(no, 80, 30);
  g_signal_connect(G_OBJECT(yes), "clicked", G_CALLBACK(yes_clicked), mywin);
  g_signal_connect(G_OBJECT(no), "clicked", G_CALLBACK(no_clicked), mywin);
  gtk_box_pack_start(GTK_BOX(hbox), yes, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(hbox), no, FALSE, FALSE, 0);
  label = gtk_label_new(argv[1]);
  gtk_widget_set_size_request(label, 300, -1);
  gtk_label_set_line_wrap(GTK_LABEL(label), TRUE);
  gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 10);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), ospacer, FALSE, FALSE, 0);
  big_hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(big_hbox), vbox, FALSE, FALSE, 10);
  gtk_container_add(GTK_CONTAINER(mywin), big_hbox);
  gtk_widget_show_all(mywin);
  gtk_main();
  return 0;
}
